Package ghidra.app.util.cparser.CPP

# Class PreProcessor

java.lang.Object
ghidra.app.util.cparser.CPP.PreProcessor

All Implemented Interfaces:
  `PreProcessorConstants`

public class PreProcessor extends Object implements PreProcessorConstants

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `Token`
  `jj_nt`
  Next token.
  `Token`
  `token`
  Current token.
  `PreProcessorTokenManager`
  `token_source`
  Generated Token Manager.

  ### Fields inherited from interface ghidra.app.util.cparser.CPP.PreProcessorConstants

  `__LT, _AND, _BLANKLINE, _BOM, _CMT, _CMT0, _CMT11, _CMT3, _CMT4, _CMT5, _COD, _COD_PRAG, _COD_WSP, _COD1, _COD2, _COD3, _COD4, _CODC, _COLON, _CTRL, _ECMT10, _ECMT3, _ECMT5, _ECMT7, _ECMT8, _ECMT9, _EECMT7, _EECMT9, _EEECMT9, _ENDREL, _EQ, _EQT, _EQT1, _GE, _GT, _HEX, _INCCOD, _INCCP, _INCOP, _INCSTANDARD, _INCWSP, _LCMT, _LCMT0, _LCMT11, _LCMT20, _LCMT21, _LCMT4, _LCMT7, _LCMTPRAG, _LE, _LEADIN1, _LEADIN2, _LOG_AND, _LOG_OR, _LSH, _LT, _MACWSP, _MINUS, _MWSP, _NEQ, _OR, _PERCENT, _PLUS, _QMARK, _QTE, _QTE0, _QTE1, _RSH, _SCMT_PRAG, _TOEOL, _WSP, _WSP_INFO, _WSP0, _WSP2, _WSP3, _WSP4, _WSP5, _WSP6, _WSP7, _WSP8, _XOR, _XSYM, _XSYMENDL, AND, BEGITEM, CMNTNL, CMT, COD, COLON, COMMA, COMMENT, CONLINE, CONSTANT, CONSTITUENT, CONTARG, CP, DECIMAL_LITERAL, DEFAULT, DEFD, DEFINE, DEFINED, DIR, DIRECTIVE, DIRECTIVECOMMENT, DIRLINE, DIVIDE, ECMT, ELIF, ELSE, ENDCMT, ENDIF, ENDITEM, ENDL, ENDREL, EOF, EOLCMNTNL, EQ, ERRLINE, ERROR, ERROR_EXPRN, ESTD, EXPATH, EXPONENT, FP_LITERAL, FP_NUMERIC, GE, GT, HASINCLUDE, HASINCLUDENEXT, HEX_DIGIT, HEX_LITERAL, IF, IFDEF, IFDEF_EXPRN, IFDEFED, IFDLINE, IFNDEF, IFNDEF_EXPRN, IFNDEFED, IFNDLINE, IGNORETOEOL, INCDEF, INCLINE, INCLUDE, INFO, INFO_EXPRN, INFOLINE, INTEGER_LITERAL, ITEM, LE, LEADIN3, LINE, LINECOMMENT, LINEINFO, LINLINE, LOG_AND, LOG_OR, LSH, LT, MACEXPPATH, MACROARGS, MACROARGSEND, MACROMV, MACROMVTAG, MACRORV, MACRORVCMT, MACROVALS, MACROVALS_COMMENT, MANIFEST, MCVLINE, MINUS, MOD, MOREARG, MOREVAL, MQUOTED_VAL, MQUOTED_VALUE, NEQ, NEWLINE, NOPAR, NOT, NOTCHR, NOTCMT, NOTCMTCOD, NOTENDL, NOTENDLC, NOTENDLSTAR, NOTVALCMT, NOTWQC, NOTWS, NOTWSQ, NOTWSQLT, NOTWWSQLT, NUMERIC, OCTAL_LITERAL, OP, OPTD, OPTIONED, OR, OTHER_TEXT, OUTER_TEXT, PLUS, PRAGLINE, PRAGMA, PRAGMA_EXPRN, QMARK, QUOTED_TEXT, QUOTED_VAL, QUOTED_VALUE, REL, RELATIVE, RELPATH, RSH, RVALUES, RVALUES_COMMENT, RVSLINE, SpecialBlockComment, SpecialEOLComment, STANDARD, STARTCMT, STD, STDPATH, TIMES, tokenImage, UNDEFINE, UNDIR, UNDIRALL, UNDLINE, VALUES, VALUESCMT, WARNING, WARNING_EXPRN, WARNLINE, WS, WSP, XOR, XSYM, XSYMLINK, XSYMLINKPATH, XSYMPATH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PreProcessor()`
  `PreProcessor(PreProcessorTokenManager tm)`
  Constructor with generated Token Manager.
  `PreProcessor(InputStream stream)`
  Constructor with InputStream.
  `PreProcessor(InputStream stream, String encoding)`
  Constructor with InputStream and supplied encoding
  `PreProcessor(Reader stream)`
  Constructor.
  `PreProcessor(String filename)`
  `PreProcessor(String[] args)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addIncludePath(String path)`
  `void`
  `addIncludePaths(String[] paths)`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `AdditiveExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ANDExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Assertion()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `CompoundAndExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `CompoundConditionalExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `CompoundOrExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ConditionalExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ControlLine()`
  `String`
  `curFileStackTop()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Define()`
  `boolean`
  `didParseSucceed()`
  `final void`
  `disable_tracing()`
  Disable tracing.
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ElIf()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Else()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ElseIfCondition()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ElseMark()`
  `final void`
  `enable_tracing()`
  Enable tracing.
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `EndIf()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `EqualityExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `EqualTo()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Error()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ExclusiveORExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Expression()`
  `ParseException`
  `generateParseException()`
  Generate ParseException.
  `ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `getDef(ghidra.app.util.cparser.CPP.PreProcessor.PPToken def)`
  `String`
  `getDef(String name)`
  `DefineTable`
  `getDefinitions()`
  `Double`
  `getDoubleValue(String val)`
  `final Token`
  `getNextToken()`
  Get the next Token.
  `int`
  `getNumericType(String val)`
  `String`
  `getParseMessages()`
  `final Token`
  `getToken(int index)`
  Get the specific Token.
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `GreaterThan()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `GreaterThanExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `GreaterThanOrEqual()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `GreaterThanOrEqualExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Group()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `GroupPart()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `If()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IfCondition()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IfDef()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IfDefExpr()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IFGroup()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IfNDef()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IfNDefExpr()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `IFSection()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Include()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `InclusiveORExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `InEqualityExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Info()`
  `final void`
  `Input()`
  `boolean`
  `isArg(ghidra.app.util.cparser.CPP.PreProcessor.PPToken arg)`
  `boolean`
  `isDef(ghidra.app.util.cparser.CPP.PreProcessor.PPToken def)`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LessExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LessThan()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LessThanOrEqual()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LessThanOrEqualExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LineInfo()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LogAnd()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LogicalAndExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LogicalOrExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LogNegation()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `LogOr()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `MacroArgs()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `MacroVals()`
  `static void`
  `main(String[] args)`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `MultiplicativeExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `NewLines()`
  `final void`
  `NoMas()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `NotEqualTo()`
  `boolean`
  `parse(String filename)`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Pragma()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Qmark()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `QuotedText()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `QuotedValue()`
  `void`
  `ReInit(PreProcessorTokenManager tm)`
  Reinitialise.
  `void`
  `ReInit(InputStream stream)`
  Reinitialise.
  `void`
  `ReInit(InputStream stream, String encoding)`
  Reinitialise.
  `void`
  `ReInit(Reader stream)`
  Reinitialise.
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `RelationalExpression()`
  `void`
  `setArgs(String[] args)`
  `void`
  `setMonitor(TaskMonitor monitor)`
  `void`
  `setOutputStream(OutputStream fos)`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ShiftExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Text()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `TranslationUnit()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `UnaryExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `UnDef()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `ValueExpression()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Values()`
  `int`
  `verboseLevel()`
  `final ghidra.app.util.cparser.CPP.PreProcessor.PPToken`
  `Warning()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### token_source

    public PreProcessorTokenManager token_source
    Generated Token Manager.

  - ### token

    public Token token
    Current token.

  - ### jj_nt

    public Token jj_nt
    Next token.

- ## Constructor Details

  - ### PreProcessor

    public PreProcessor(String[] args) throws ParseException
    Throws:
      `ParseException`

  - ### PreProcessor

    public PreProcessor(String filename) throws ParseException
    Throws:
      `ParseException`

  - ### PreProcessor

    public PreProcessor() throws ParseException
    Throws:
      `ParseException`

  - ### PreProcessor

    public PreProcessor(InputStream stream)
    Constructor with InputStream.

  - ### PreProcessor

    public PreProcessor(InputStream stream, String encoding)
    Constructor with InputStream and supplied encoding

  - ### PreProcessor

    public PreProcessor(Reader stream)
    Constructor.

  - ### PreProcessor

    public PreProcessor(PreProcessorTokenManager tm)
    Constructor with generated Token Manager.

- ## Method Details

  - ### verboseLevel

    public int verboseLevel()

  - ### curFileStackTop

    public String curFileStackTop()

  - ### getDefinitions

    public DefineTable getDefinitions()

  - ### getDef

    public ghidra.app.util.cparser.CPP.PreProcessor.PPToken getDef(ghidra.app.util.cparser.CPP.PreProcessor.PPToken def)

  - ### getDef

    public String getDef(String name)

  - ### isDef

    public boolean isDef(ghidra.app.util.cparser.CPP.PreProcessor.PPToken def)

  - ### isArg

    public boolean isArg(ghidra.app.util.cparser.CPP.PreProcessor.PPToken arg)

  - ### addIncludePath

    public void addIncludePath(String path)

  - ### addIncludePaths

    public void addIncludePaths(String[] paths)

  - ### getNumericType

    public int getNumericType(String val)

  - ### getDoubleValue

    public Double getDoubleValue(String val)

  - ### getParseMessages

    public String getParseMessages()

  - ### didParseSucceed

    public boolean didParseSucceed()

  - ### setArgs

    public void setArgs(String[] args) throws ParseException
    Throws:
      `ParseException`

  - ### setOutputStream

    public void setOutputStream(OutputStream fos)

  - ### parse

    public boolean parse(String filename) throws ParseException
    Throws:
      `ParseException`

  - ### setMonitor

    public void setMonitor(TaskMonitor monitor)

  - ### main

    public static void main(String[] args)

  - ### Input

    public final void Input() throws ParseException
    Throws:
      `ParseException`

  - ### TranslationUnit

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken TranslationUnit() throws ParseException
    Throws:
      `ParseException`

  - ### NoMas

    public final void NoMas() throws ParseException
    Throws:
      `ParseException`

  - ### Group

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Group() throws ParseException
    Throws:
      `ParseException`

  - ### GroupPart

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken GroupPart() throws ParseException
    Throws:
      `ParseException`

  - ### ControlLine

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ControlLine() throws ParseException
    Throws:
      `ParseException`

  - ### IFSection

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IFSection() throws ParseException
    Throws:
      `ParseException`

  - ### IFGroup

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IFGroup() throws ParseException
    Throws:
      `ParseException`

  - ### IfCondition

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IfCondition() throws ParseException
    Throws:
      `ParseException`

  - ### ElseIfCondition

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ElseIfCondition() throws ParseException
    Throws:
      `ParseException`

  - ### Include

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Include() throws ParseException
    Throws:
      `ParseException`

  - ### LineInfo

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LineInfo() throws ParseException
    Throws:
      `ParseException`

  - ### Define

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Define() throws ParseException
    Throws:
      `ParseException`

  - ### UnDef

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken UnDef() throws ParseException
    Throws:
      `ParseException`

  - ### MacroArgs

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken MacroArgs() throws ParseException
    Throws:
      `ParseException`

  - ### MacroVals

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken MacroVals() throws ParseException
    Throws:
      `ParseException`

  - ### Pragma

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Pragma() throws ParseException
    Throws:
      `ParseException`

  - ### IfDef

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IfDef() throws ParseException
    Throws:
      `ParseException`

  - ### IfDefExpr

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IfDefExpr() throws ParseException
    Throws:
      `ParseException`

  - ### IfNDef

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IfNDef() throws ParseException
    Throws:
      `ParseException`

  - ### IfNDefExpr

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken IfNDefExpr() throws ParseException
    Throws:
      `ParseException`

  - ### Error

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Error() throws ParseException
    Throws:
      `ParseException`

  - ### Warning

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Warning() throws ParseException
    Throws:
      `ParseException`

  - ### Info

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Info() throws ParseException
    Throws:
      `ParseException`

  - ### EndIf

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken EndIf() throws ParseException
    Throws:
      `ParseException`

  - ### Else

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Else() throws ParseException
    Throws:
      `ParseException`

  - ### If

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken If() throws ParseException
    Throws:
      `ParseException`

  - ### ElIf

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ElIf() throws ParseException
    Throws:
      `ParseException`

  - ### Values

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Values() throws ParseException
    Throws:
      `ParseException`

  - ### QuotedValue

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken QuotedValue() throws ParseException
    Throws:
      `ParseException`

  - ### Text

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Text() throws ParseException
    Throws:
      `ParseException`

  - ### NewLines

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken NewLines() throws ParseException
    Throws:
      `ParseException`

  - ### QuotedText

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken QuotedText() throws ParseException
    Throws:
      `ParseException`

  - ### CompoundConditionalExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken CompoundConditionalExpression() throws ParseException
    Throws:
      `ParseException`

  - ### CompoundAndExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken CompoundAndExpression() throws ParseException
    Throws:
      `ParseException`

  - ### CompoundOrExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken CompoundOrExpression() throws ParseException
    Throws:
      `ParseException`

  - ### ConditionalExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ConditionalExpression() throws ParseException
    Throws:
      `ParseException`

  - ### LogicalOrExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LogicalOrExpression() throws ParseException
    Throws:
      `ParseException`

  - ### LogicalAndExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LogicalAndExpression() throws ParseException
    Throws:
      `ParseException`

  - ### EqualityExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken EqualityExpression() throws ParseException
    Throws:
      `ParseException`

  - ### InEqualityExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken InEqualityExpression() throws ParseException
    Throws:
      `ParseException`

  - ### RelationalExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken RelationalExpression() throws ParseException
    Throws:
      `ParseException`

  - ### LessExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LessExpression() throws ParseException
    Throws:
      `ParseException`

  - ### LessThanOrEqualExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LessThanOrEqualExpression() throws ParseException
    Throws:
      `ParseException`

  - ### GreaterThanOrEqualExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken GreaterThanOrEqualExpression() throws ParseException
    Throws:
      `ParseException`

  - ### GreaterThanExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken GreaterThanExpression() throws ParseException
    Throws:
      `ParseException`

  - ### LogOr

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LogOr() throws ParseException
    Throws:
      `ParseException`

  - ### LogAnd

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LogAnd() throws ParseException
    Throws:
      `ParseException`

  - ### EqualTo

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken EqualTo() throws ParseException
    Throws:
      `ParseException`

  - ### NotEqualTo

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken NotEqualTo() throws ParseException
    Throws:
      `ParseException`

  - ### LessThan

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LessThan() throws ParseException
    Throws:
      `ParseException`

  - ### LessThanOrEqual

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LessThanOrEqual() throws ParseException
    Throws:
      `ParseException`

  - ### GreaterThan

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken GreaterThan() throws ParseException
    Throws:
      `ParseException`

  - ### GreaterThanOrEqual

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken GreaterThanOrEqual() throws ParseException
    Throws:
      `ParseException`

  - ### Qmark

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Qmark() throws ParseException
    Throws:
      `ParseException`

  - ### ElseMark

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ElseMark() throws ParseException
    Throws:
      `ParseException`

  - ### Assertion

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Assertion() throws ParseException
    Throws:
      `ParseException`

  - ### Expression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken Expression() throws ParseException
    Throws:
      `ParseException`

  - ### InclusiveORExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken InclusiveORExpression() throws ParseException
    Throws:
      `ParseException`

  - ### ExclusiveORExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ExclusiveORExpression() throws ParseException
    Throws:
      `ParseException`

  - ### ANDExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ANDExpression() throws ParseException
    Throws:
      `ParseException`

  - ### ShiftExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ShiftExpression() throws ParseException
    Throws:
      `ParseException`

  - ### AdditiveExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken AdditiveExpression() throws ParseException
    Throws:
      `ParseException`

  - ### MultiplicativeExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken MultiplicativeExpression() throws ParseException
    Throws:
      `ParseException`

  - ### UnaryExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken UnaryExpression() throws ParseException
    Throws:
      `ParseException`

  - ### LogNegation

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken LogNegation() throws ParseException
    Throws:
      `ParseException`

  - ### ValueExpression

    public final ghidra.app.util.cparser.CPP.PreProcessor.PPToken ValueExpression() throws ParseException
    Throws:
      `ParseException`

  - ### ReInit

    public void ReInit(InputStream stream)
    Reinitialise.

  - ### ReInit

    public void ReInit(InputStream stream, String encoding)
    Reinitialise.

  - ### ReInit

    public void ReInit(Reader stream)
    Reinitialise.

  - ### ReInit

    public void ReInit(PreProcessorTokenManager tm)
    Reinitialise.

  - ### getNextToken

    public final Token getNextToken()
    Get the next Token.

  - ### getToken

    public final Token getToken(int index)
    Get the specific Token.

  - ### generateParseException

    public ParseException generateParseException()
    Generate ParseException.

  - ### enable_tracing

    public final void enable_tracing()
    Enable tracing.

  - ### disable_tracing

    public final void disable_tracing()
    Disable tracing.